/*
 * robocraft.cpp 
 *
 * RoboCraft -    RoboCraft.ru
 *
 * Written by noonv, July 2009.
 */

#ifndef robocraft_cpp
#define robocraft_cpp

#include "robocraft.h"

//
//  -       RoboCraft
//
RoboCraft::RoboCraft()
{
	Serial.begin(9600);
}

//
//  -   
//
RoboCraft::RoboCraft(MOTOR *m1, MOTOR *m2)
{
	Serial.begin(9600);
	if(m1)
	{
		MOTOR1.in1 = m1->in1;
		MOTOR1.in2 = m1->in2;
		MOTOR1.enable = m1->enable;
		set_m_pins(m1);
	}
	if(m2)
	{
		MOTOR2.in1 = m2->in1;
		MOTOR2.in2 = m2->in2;
		MOTOR2.enable = m2->enable;
		set_m_pins(m2);
	}
}

//
//   "Hello" :)
//
void RoboCraft::hello()
{
	Serial.println("Hello :)");
}

//
//  
//    (1  2)     (0-255)
//     1  2 -   
//
void RoboCraft::motor_forward(int m, int speed)
{
	switch(m)
	{
		case 1:
			m_forward(&MOTOR1,speed);
			break;
		case 2:
			m_forward(&MOTOR2,speed);
			break;
		default:
			m_forward(&MOTOR1,speed);
			m_forward(&MOTOR2,speed);
			break;
	}
}

//
//  
//    (1  2)     (0-255)
//     1  2 -   
//
void RoboCraft::motor_back(int m, int speed)
{
	switch(m)
	{
		case 1:
			m_back(&MOTOR1,speed);
			break;
		case 2:
			m_back(&MOTOR2,speed);
			break;
		default:
			m_back(&MOTOR1,speed);
			m_back(&MOTOR2,speed);
			break;
	}
}

//
//     
//
void RoboCraft::set_m_pins(MOTOR *m)
{
	if(m)
	{
		pinMode(m->in1, OUTPUT);
		pinMode(m->in2, OUTPUT);
		//pinMode(m->enable, OUTPUT);
	}
}

//
//   
//
void RoboCraft::m_forward(MOTOR *m,int speed)
{
	if(m)
	{
		Serial.println("[i] forward");
		digitalWrite(m->in1, HIGH);
		digitalWrite(m->in2, LOW);
		//digitalWrite(m->enable, HIGH);
		analogWrite(m->enable, speed);
	}
	else
	{
		Serial.println("[!] error");
	}
}

//
//   
//
void RoboCraft::m_back(MOTOR *m,int speed)
{
	if(m)
	{
		Serial.println("[i] back");
		digitalWrite(m->in1, LOW);
		digitalWrite(m->in2, HIGH);
		//digitalWrite(m->enable, HIGH);
		analogWrite(m->enable, speed);
	}
	else
	{
		Serial.println("[!] error");
	}
}

#endif // #ifndef robocraft_cpp